/*
 * (c) Copyright 2024 Swiss Post Ltd.
 */
CREATE TABLE QUEUED_COMPUTE_CHUNK_IDS_ENTITY
(
    ELECTION_EVENT_ID           VARCHAR2(255 CHAR) NOT NULL,
    VERIFICATION_CARD_SET_ID    VARCHAR2(255 CHAR) NOT NULL,
    CHUNK_ID                    NUMBER(10) NOT NULL,
    CONSTRAINT QUEUED_COMPUTE_CHUNK_IDS_ENTITY_PK PRIMARY KEY (ELECTION_EVENT_ID, VERIFICATION_CARD_SET_ID, CHUNK_ID)
);


 CREATE TABLE IN_PROGRESS_MESSAGE
 (
    CORRELATION_ID             VARCHAR2(255 CHAR) NOT NULL,
    NODE_ID                    NUMBER(10) NOT NULL,
    REQUEST_MESSAGE_TYPE       VARCHAR2(255 CHAR) NOT NULL,
    CONTEXT_ID                 VARCHAR2(255 CHAR) NOT NULL,
    RESPONSE_MESSAGE_TYPE      VARCHAR2(255 CHAR),
    RESPONSE_PAYLOAD           BLOB,
    DETECTED_FOR_AGGREGATION   CHAR(1) DEFAULT 'N' NOT NULL,
    CONSTRAINT IN_PROGRESS_MESSAGE_PK PRIMARY KEY (CORRELATION_ID, NODE_ID)
 );

CREATE TABLE CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD
(
    ID                NUMBER(18)    NOT NULL,
    ELECTION_EVENT_ID VARCHAR2(100) NOT NULL,
    BALLOT_BOX_ID     VARCHAR2(100) NOT NULL,
    NODE_ID           NUMBER(10)    NOT NULL,
    PAYLOAD           BLOB          NOT NULL,
    CHANGE_CONTROL_ID NUMBER(10)    NOT NULL,
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_UK1 UNIQUE (ELECTION_EVENT_ID, BALLOT_BOX_ID, NODE_ID),
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_SEQ;

CREATE TABLE CONTROL_COMPONENT_VOTES_HASH_PAYLOAD
(
    ID                INTEGER            NOT NULL,
    ELECTION_EVENT_ID VARCHAR2(255 CHAR) NOT NULL,
    BALLOT_BOX_ID     VARCHAR2(255 CHAR) NOT NULL,
    NODE_ID           NUMBER(10)         NOT NULL,
    PAYLOAD           BLOB               NOT NULL,
    CHANGE_CONTROL_ID NUMBER(9, 0)       NOT NULL,
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_UK1 UNIQUE (BALLOT_BOX_ID, ELECTION_EVENT_ID, NODE_ID),
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_SEQ;

CREATE TABLE SHUFFLE_PAYLOAD
(
    ID                INTEGER            NOT NULL,
    ELECTION_EVENT_ID VARCHAR2(255 CHAR) NOT NULL,
    BALLOT_BOX_ID     VARCHAR2(255 CHAR) NOT NULL,
    NODE_ID           NUMBER(10)         NOT NULL,
    PAYLOAD           BLOB               NOT NULL,
    CHANGE_CONTROL_ID NUMBER(9, 0)       NOT NULL,
    CONSTRAINT SHUFFLE_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT SHUFFLE_PAYLOAD_UK1 UNIQUE (BALLOT_BOX_ID, ELECTION_EVENT_ID, NODE_ID),
    CONSTRAINT SHUFFLE_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE SHUFFLE_PAYLOAD_SEQ;


CREATE TABLE ENC_LONG_CODE_SHARE
(
    ID                       NUMBER(18)    NOT NULL,
    ELECTION_EVENT_ID        VARCHAR2(100) NOT NULL,
    VERIFICATION_CARD_SET_ID VARCHAR2(100) NOT NULL,
    CHUNK_ID                 NUMBER(10),
    NODE_ID                  NUMBER(10)    NOT NULL,
    ENC_LONG_CODE_SHARE      BLOB          NOT NULL,
    CHANGE_CONTROL_ID        NUMBER(10)    NOT NULL,
    CONSTRAINT ENC_LONG_CODE_SHARE_PK PRIMARY KEY (ID),
    CONSTRAINT ENC_LONG_CODE_SHARE_UK1 UNIQUE (ELECTION_EVENT_ID, VERIFICATION_CARD_SET_ID, CHUNK_ID, NODE_ID),
    CONSTRAINT ENC_LONG_CODE_SHARE_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE ENC_LONG_CODE_SHARE_SEQ;


CREATE TABLE WORKFLOW_SHELF
(
    ID            VARCHAR2(100)            NOT NULL,
    SHELF_DATA    BLOB                     NOT NULL,
    CREATION_DATE TIMESTAMP WITH TIME ZONE NOT NULL,
    CONSTRAINT WORKFLOW_SHELF_PK PRIMARY KEY (ID)
);

CREATE TABLE ELECTION_EVENT
(
    ELECTION_EVENT_ID VARCHAR2(32) NOT NULL,
    ENCRYPTION_GROUP  BLOB         NOT NULL,
    CHANGE_CONTROL_ID NUMBER(1)    NOT NULL,
    CONSTRAINT ELECTION_EVENT_PK PRIMARY KEY (ELECTION_EVENT_ID),
    CONSTRAINT ELECTION_EVENT_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE ELECTION_EVENT_CONTEXT
(
    ELECTION_EVENT_ID          VARCHAR2(32)             NOT NULL,
    START_TIME                 TIMESTAMP WITH TIME ZONE NOT NULL,
    FINISH_TIME                TIMESTAMP WITH TIME ZONE NOT NULL,
    ELECTION_EVENT_ALIAS       VARCHAR2(50)             NOT NULL,
    ELECTION_EVENT_DESCRIPTION VARCHAR2(255)            NOT NULL,
    CHANGE_CONTROL_ID          NUMBER(1)                NOT NULL,
    CONSTRAINT ELECTION_EVENT_CONTEXT_PK PRIMARY KEY (ELECTION_EVENT_ID),
    FOREIGN KEY (ELECTION_EVENT_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT ELECTION_EVENT_CONTEXT_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE BALLOT_DATA
(
    BALLOT_ID            VARCHAR2(32) NOT NULL,
    ELECTION_EVENT_FK_ID VARCHAR2(32) NOT NULL,
    BALLOT               BLOB         NOT NULL,
    BALLOT_TEXTS_JSON    BLOB         NOT NULL,
    CHANGE_CONTROL_ID    NUMBER(1)    NOT NULL,
    CONSTRAINT BALLOT_DATA_PK PRIMARY KEY (BALLOT_ID),
    FOREIGN KEY (ELECTION_EVENT_FK_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT BALLOT_DATA_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE SETUP_COMPONENT_PUBLIC_KEYS
(
    ELECTION_EVENT_ID                         VARCHAR2(32) NOT NULL,
    CHOICE_RETURN_CODES_ENCRYPTION_PUBLIC_KEY BLOB         NOT NULL,
    COMBINED_CONTROL_COMPONENT_PUBLIC_KEYS    BLOB         NOT NULL,
    ELECTION_PUBLIC_KEY                       BLOB         NOT NULL,
    ELECTORAL_BOARD_PUBLIC_KEY                BLOB         NOT NULL,
    ELECTORAL_BOARD_SCHNORR_PROOFS            BLOB         NOT NULL,
    CHANGE_CONTROL_ID                         NUMBER(1)    NOT NULL,
    CONSTRAINT SETUP_COMPONENT_PUBLIC_KEYS_PK PRIMARY KEY (ELECTION_EVENT_ID),
    FOREIGN KEY (ELECTION_EVENT_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT SETUP_COMPONENT_PUBLIC_KEYS_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD_SET
(
    VERIFICATION_CARD_SET_ID VARCHAR2(32)             NOT NULL,
    ELECTION_EVENT_FK_ID     VARCHAR2(32)             NOT NULL,
    BALLOT_BOX_ID            VARCHAR2(32)             NOT NULL,
    GRACE_PERIOD             NUMBER(5)                NOT NULL,
    PRIMES_MAPPING_TABLE     BLOB                     NOT NULL,
    BALLOT_BOX_START_TIME    TIMESTAMP WITH TIME ZONE NOT NULL,
    BALLOT_BOX_FINISH_TIME   TIMESTAMP WITH TIME ZONE NOT NULL,
    TEST_BALLOT_BOX          CHAR(1) DEFAULT 'N'      NOT NULL,
    CHANGE_CONTROL_ID        NUMBER(1)                NOT NULL,
    CONSTRAINT VERIFICATION_CARD_SET_PK PRIMARY KEY (VERIFICATION_CARD_SET_ID),
    FOREIGN KEY (ELECTION_EVENT_FK_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT GRACE_PERIOD_POSITIVITY_CK CHECK (GRACE_PERIOD >= 0),
    CONSTRAINT VERIFICATION_CARD_SET_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE RETURN_CODES_MAPPING_TABLE_ENTRY
(
    VERIFICATION_CARD_SET_ID    VARCHAR2(32) NOT NULL,
    HASHED_LONG_RETURN_CODE     VARCHAR2(44) NOT NULL,
    ENCRYPTED_SHORT_RETURN_CODE VARCHAR2(48) NOT NULL,
    CHANGE_CONTROL_ID           NUMBER(1)    NOT NULL,
    CONSTRAINT RETURN_CODES_MAPPING_TABLE_ENTRY_PK PRIMARY KEY (HASHED_LONG_RETURN_CODE),
    FOREIGN KEY (VERIFICATION_CARD_SET_ID) REFERENCES VERIFICATION_CARD_SET (VERIFICATION_CARD_SET_ID),
    CONSTRAINT RETURN_CODES_MAPPING_TABLE_ENTRY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD
(
    VERIFICATION_CARD_ID        VARCHAR2(32) NOT NULL,
    VERIFICATION_CARD_SET_FK_ID VARCHAR2(32) NOT NULL,
    CREDENTIAL_ID               VARCHAR2(32) NOT NULL UNIQUE,
    VOTING_CARD_ID              VARCHAR2(32) NOT NULL,
    VOTER_AUTHENTICATION_DATA   BLOB         NOT NULL,
    CHANGE_CONTROL_ID           NUMBER(1)    NOT NULL,
    CONSTRAINT VERIFICATION_CARD_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_SET_FK_ID) REFERENCES VERIFICATION_CARD_SET (VERIFICATION_CARD_SET_ID),
    CONSTRAINT VERIFICATION_CARD_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);
CREATE UNIQUE INDEX VOTING_CARD_ID_UK1 ON VERIFICATION_CARD (VOTING_CARD_ID);

CREATE TABLE SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE
(
    VERIFICATION_CARD_ID       VARCHAR2(32) NOT NULL,
    VERIFICATION_CARD_KEYSTORE BLOB         NOT NULL,
    CHANGE_CONTROL_ID          NUMBER(1)    NOT NULL,
    CONSTRAINT SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_ID) REFERENCES VERIFICATION_CARD (VERIFICATION_CARD_ID),
    CONSTRAINT SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD_STATE
(
    VERIFICATION_CARD_ID                     VARCHAR2(32)             NOT NULL,
    SHORT_CHOICE_RETURN_CODES                BLOB,
    SHORT_VOTE_CAST_RETURN_CODE              VARCHAR2(8),
    STATE                                    NUMBER(1)                NOT NULL,
    AUTHENTICATION_ATTEMPTS                  NUMBER(1)                NOT NULL,
    LAST_SUCCESSFUL_AUTHENTICATION_TIME_STEP NUMBER(19)               NOT NULL,
    SUCCESSFUL_AUTHENTICATION_ATTEMPTS       BLOB                     NOT NULL,
    CONFIRMATION_ATTEMPTS                    NUMBER(1)                NOT NULL,
    STATE_DATE                               TIMESTAMP WITH TIME ZONE NOT NULL,
    CHANGE_CONTROL_ID                        NUMBER(10)               NOT NULL,
    CONSTRAINT VERIFICATION_CARD_STATE_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_ID) REFERENCES VERIFICATION_CARD (VERIFICATION_CARD_ID)
);

CREATE TABLE IDEMPOTENT_EXECUTION
(
    CONTEXT           VARCHAR2(255 CHAR) NOT NULL,
    EXECUTION_KEY     VARCHAR2(255 CHAR) NOT NULL,
    CHANGE_CONTROL_ID NUMBER(1)          NOT NULL,
    CONSTRAINT IDEMPOTENT_EXECUTION_PK PRIMARY KEY (CONTEXT, EXECUTION_KEY),
    CONSTRAINT IDEMPOTENT_EXECUTION_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);




-- QUARTZ DATABASE SCRIPTS

CREATE TABLE qrtz_job_details
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    JOB_NAME  VARCHAR2(200) NOT NULL,
    JOB_GROUP VARCHAR2(200) NOT NULL,
    DESCRIPTION VARCHAR2(250) NULL,
    JOB_CLASS_NAME   VARCHAR2(250) NOT NULL,
    IS_DURABLE VARCHAR2(1) NOT NULL,
    IS_NONCONCURRENT VARCHAR2(1) NOT NULL,
    IS_UPDATE_DATA VARCHAR2(1) NOT NULL,
    REQUESTS_RECOVERY VARCHAR2(1) NOT NULL,
    JOB_DATA BLOB NULL,
    CONSTRAINT QRTZ_JOB_DETAILS_PK PRIMARY KEY (SCHED_NAME,JOB_NAME,JOB_GROUP)
);
CREATE TABLE qrtz_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    JOB_NAME  VARCHAR2(200) NOT NULL,
    JOB_GROUP VARCHAR2(200) NOT NULL,
    DESCRIPTION VARCHAR2(250) NULL,
    NEXT_FIRE_TIME NUMBER(13) NULL,
    PREV_FIRE_TIME NUMBER(13) NULL,
    PRIORITY NUMBER(13) NULL,
    TRIGGER_STATE VARCHAR2(16) NOT NULL,
    TRIGGER_TYPE VARCHAR2(8) NOT NULL,
    START_TIME NUMBER(13) NOT NULL,
    END_TIME NUMBER(13) NULL,
    CALENDAR_NAME VARCHAR2(200) NULL,
    MISFIRE_INSTR NUMBER(2) NULL,
    JOB_DATA BLOB NULL,
    CONSTRAINT QRTZ_TRIGGERS_PK PRIMARY KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP),
    CONSTRAINT QRTZ_TRIGGER_TO_JOBS_FK FOREIGN KEY (SCHED_NAME,JOB_NAME,JOB_GROUP)
        REFERENCES QRTZ_JOB_DETAILS(SCHED_NAME,JOB_NAME,JOB_GROUP)
);
CREATE TABLE qrtz_simple_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    REPEAT_COUNT NUMBER(7) NOT NULL,
    REPEAT_INTERVAL NUMBER(12) NOT NULL,
    TIMES_TRIGGERED NUMBER(10) NOT NULL,
    CONSTRAINT QRTZ_SIMPLE_TRIG_PK PRIMARY KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP),
    CONSTRAINT QRTZ_SIMPLE_TRIG_TO_TRIG_FK FOREIGN KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_cron_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    CRON_EXPRESSION VARCHAR2(120) NOT NULL,
    TIME_ZONE_ID VARCHAR2(80),
    CONSTRAINT QRTZ_CRON_TRIG_PK PRIMARY KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP),
    CONSTRAINT QRTZ_CRON_TRIG_TO_TRIG_FK FOREIGN KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_simprop_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    STR_PROP_1 VARCHAR2(512) NULL,
    STR_PROP_2 VARCHAR2(512) NULL,
    STR_PROP_3 VARCHAR2(512) NULL,
    INT_PROP_1 NUMBER(10) NULL,
    INT_PROP_2 NUMBER(10) NULL,
    LONG_PROP_1 NUMBER(13) NULL,
    LONG_PROP_2 NUMBER(13) NULL,
    DEC_PROP_1 NUMERIC(13,4) NULL,
    DEC_PROP_2 NUMERIC(13,4) NULL,
    BOOL_PROP_1 VARCHAR2(1) NULL,
    BOOL_PROP_2 VARCHAR2(1) NULL,
    CONSTRAINT QRTZ_SIMPROP_TRIG_PK PRIMARY KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP),
    CONSTRAINT QRTZ_SIMPROP_TRIG_TO_TRIG_FK FOREIGN KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_blob_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    BLOB_DATA BLOB NULL,
    CONSTRAINT QRTZ_BLOB_TRIG_PK PRIMARY KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP),
    CONSTRAINT QRTZ_BLOB_TRIG_TO_TRIG_FK FOREIGN KEY (SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_calendars
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    CALENDAR_NAME  VARCHAR2(200) NOT NULL,
    CALENDAR BLOB NOT NULL,
    CONSTRAINT QRTZ_CALENDARS_PK PRIMARY KEY (SCHED_NAME,CALENDAR_NAME)
);
CREATE TABLE qrtz_paused_trigger_grps
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    TRIGGER_GROUP  VARCHAR2(200) NOT NULL,
    CONSTRAINT QRTZ_PAUSED_TRIG_GRPS_PK PRIMARY KEY (SCHED_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_fired_triggers
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    ENTRY_ID VARCHAR2(95) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    INSTANCE_NAME VARCHAR2(200) NOT NULL,
    FIRED_TIME NUMBER(13) NOT NULL,
    SCHED_TIME NUMBER(13) NOT NULL,
    PRIORITY NUMBER(13) NOT NULL,
    STATE VARCHAR2(16) NOT NULL,
    JOB_NAME VARCHAR2(200) NULL,
    JOB_GROUP VARCHAR2(200) NULL,
    IS_NONCONCURRENT VARCHAR2(1) NULL,
    REQUESTS_RECOVERY VARCHAR2(1) NULL,
    CONSTRAINT QRTZ_FIRED_TRIGGER_PK PRIMARY KEY (SCHED_NAME,ENTRY_ID)
);
CREATE TABLE qrtz_scheduler_state
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    INSTANCE_NAME VARCHAR2(200) NOT NULL,
    LAST_CHECKIN_TIME NUMBER(13) NOT NULL,
    CHECKIN_INTERVAL NUMBER(13) NOT NULL,
    CONSTRAINT QRTZ_SCHEDULER_STATE_PK PRIMARY KEY (SCHED_NAME,INSTANCE_NAME)
);
CREATE TABLE qrtz_locks
(
    SCHED_NAME VARCHAR2(120) NOT NULL,
    LOCK_NAME  VARCHAR2(40) NOT NULL,
    CONSTRAINT QRTZ_LOCKS_PK PRIMARY KEY (SCHED_NAME,LOCK_NAME)
);

create index idx_qrtz_j_req_recovery on qrtz_job_details(SCHED_NAME,REQUESTS_RECOVERY);
create index idx_qrtz_j_grp on qrtz_job_details(SCHED_NAME,JOB_GROUP);

create index idx_qrtz_t_j on qrtz_triggers(SCHED_NAME,JOB_NAME,JOB_GROUP);
create index idx_qrtz_t_jg on qrtz_triggers(SCHED_NAME,JOB_GROUP);
create index idx_qrtz_t_c on qrtz_triggers(SCHED_NAME,CALENDAR_NAME);
create index idx_qrtz_t_g on qrtz_triggers(SCHED_NAME,TRIGGER_GROUP);
create index idx_qrtz_t_state on qrtz_triggers(SCHED_NAME,TRIGGER_STATE);
create index idx_qrtz_t_n_state on qrtz_triggers(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP,TRIGGER_STATE);
create index idx_qrtz_t_n_g_state on qrtz_triggers(SCHED_NAME,TRIGGER_GROUP,TRIGGER_STATE);
create index idx_qrtz_t_next_fire_time on qrtz_triggers(SCHED_NAME,NEXT_FIRE_TIME);
create index idx_qrtz_t_nft_st on qrtz_triggers(SCHED_NAME,TRIGGER_STATE,NEXT_FIRE_TIME);
create index idx_qrtz_t_nft_misfire on qrtz_triggers(SCHED_NAME,MISFIRE_INSTR,NEXT_FIRE_TIME);
create index idx_qrtz_t_nft_st_misfire on qrtz_triggers(SCHED_NAME,MISFIRE_INSTR,NEXT_FIRE_TIME,TRIGGER_STATE);
create index idx_qrtz_t_nft_st_misfire_grp on qrtz_triggers(SCHED_NAME,MISFIRE_INSTR,NEXT_FIRE_TIME,TRIGGER_GROUP,TRIGGER_STATE);

create index idx_qrtz_ft_trig_inst_name on qrtz_fired_triggers(SCHED_NAME,INSTANCE_NAME);
create index idx_qrtz_ft_inst_job_req_rcvry on qrtz_fired_triggers(SCHED_NAME,INSTANCE_NAME,REQUESTS_RECOVERY);
create index idx_qrtz_ft_j_g on qrtz_fired_triggers(SCHED_NAME,JOB_NAME,JOB_GROUP);
create index idx_qrtz_ft_jg on qrtz_fired_triggers(SCHED_NAME,JOB_GROUP);
create index idx_qrtz_ft_t_g on qrtz_fired_triggers(SCHED_NAME,TRIGGER_NAME,TRIGGER_GROUP);
create index idx_qrtz_ft_tg on qrtz_fired_triggers(SCHED_NAME,TRIGGER_GROUP);
